Skip to main content
PUT
/
v2
/
alert_sources
/
{id}
Update
curl --request PUT \
  --url https://api.incident.io/v2/alert_sources/{id} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data @- <<EOF
{
  "auto_resolve_incident_alerts": false,
  "auto_resolve_timeout_minutes": 1,
  "disabled": false,
  "email_options": {
    "redactions": [
      "credit_card_numbers"
    ],
    "transform_expression": "return {\n  title: $.subject,\n  description: $.text,\n  status: $.subject.startsWith('[RESOLVED]') ? 'resolved' : 'firing',\n  deduplication_key: $.header_message_id,\n}"
  },
  "heartbeat_options": {
    "failure_threshold": 1,
    "grace_period_seconds": 0,
    "interval_seconds": 60
  },
  "http_custom_options": {
    "deduplication_key_path": "$.alert_id",
    "transform_expression": "return {\n  title: $.title || $.name || 'Unknown Alert',\n  status: $.status === 'resolved' ? 'resolved' : 'firing',\n  description: $.description || $.message || '',\n  sourceURL: $.url || $.link || '',\n  metadata: { team: $.team, severity: $.severity }\n}"
  },
  "jira_options": {
    "project_ids": [
      "01GBSQF3FHF7FWZQNWGHAVQ804",
      "10043"
    ]
  },
  "name": "Production Web Dashboard Alerts",
  "owning_team_ids": [
    "01G0J1EXE7AXZ2C93K61WBPYEH"
  ],
  "template": {
    "attributes": [
      {
        "alert_attribute_id": "abc123",
        "binding": {
          "array_value": [
            {
              "literal": "SEV123",
              "reference": "incident.severity"
            }
          ],
          "merge_strategy": "first_wins",
          "value": {
            "literal": "SEV123",
            "reference": "incident.severity"
          }
        }
      }
    ],
    "description": {
      "literal": "SEV123",
      "reference": "incident.severity"
    },
    "expressions": [
      {
        "else_branch": {
          "result": {
            "array_value": [
              {
                "literal": "SEV123",
                "reference": "incident.severity"
              }
            ],
            "value": {
              "literal": "SEV123",
              "reference": "incident.severity"
            }
          }
        },
        "label": "Team Slack channel",
        "operations": [
          {
            "branches": {
              "branches": [
                {
                  "condition_groups": [
                    {
                      "conditions": [
                        {
                          "operation": "one_of",
                          "param_bindings": [
                            {
                              "array_value": [
                                {
                                  "literal": "SEV123",
                                  "reference": "incident.severity"
                                }
                              ],
                              "value": {
                                "literal": "SEV123",
                                "reference": "incident.severity"
                              }
                            }
                          ],
                          "subject": "incident.severity"
                        }
                      ]
                    }
                  ],
                  "result": {
                    "array_value": [
                      {
                        "literal": "SEV123",
                        "reference": "incident.severity"
                      }
                    ],
                    "value": {
                      "literal": "SEV123",
                      "reference": "incident.severity"
                    }
                  }
                }
              ],
              "returns": {
                "array": true,
                "type": "IncidentStatus"
              }
            },
            "cast": {
              "returns": {
                "array": true,
                "type": "IncidentStatus"
              }
            },
            "concatenate": {
              "reference": "catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]"
            },
            "filter": {
              "condition_groups": [
                {
                  "conditions": [
                    {
                      "operation": "one_of",
                      "param_bindings": [
                        {
                          "array_value": [
                            {
                              "literal": "SEV123",
                              "reference": "incident.severity"
                            }
                          ],
                          "value": {
                            "literal": "SEV123",
                            "reference": "incident.severity"
                          }
                        }
                      ],
                      "subject": "incident.severity"
                    }
                  ]
                }
              ]
            },
            "navigate": {
              "reference": "catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]"
            },
            "operation_type": "navigate",
            "parse": {
              "returns": {
                "array": true,
                "type": "IncidentStatus"
              },
              "source": "metadata.annotations[\"github.com/repo\"]"
            }
          }
        ],
        "reference": "abc123",
        "root_reference": "incident.status"
      }
    ],
    "is_private": false,
    "title": {
      "literal": "SEV123",
      "reference": "incident.severity"
    },
    "visible_to_teams": {
      "array_value": [
        {
          "literal": "SEV123",
          "reference": "incident.severity"
        }
      ],
      "value": {
        "literal": "SEV123",
        "reference": "incident.severity"
      }
    }
  }
}
EOF
import requests

url = "https://api.incident.io/v2/alert_sources/{id}"

payload = {
"auto_resolve_incident_alerts": False,
"auto_resolve_timeout_minutes": 1,
"disabled": False,
"email_options": {
"redactions": ["credit_card_numbers"],
"transform_expression": "return {
title: $.subject,
description: $.text,
status: $.subject.startsWith('[RESOLVED]') ? 'resolved' : 'firing',
deduplication_key: $.header_message_id,
}"
},
"heartbeat_options": {
"failure_threshold": 1,
"grace_period_seconds": 0,
"interval_seconds": 60
},
"http_custom_options": {
"deduplication_key_path": "$.alert_id",
"transform_expression": "return {
title: $.title || $.name || 'Unknown Alert',
status: $.status === 'resolved' ? 'resolved' : 'firing',
description: $.description || $.message || '',
sourceURL: $.url || $.link || '',
metadata: { team: $.team, severity: $.severity }
}"
},
"jira_options": { "project_ids": ["01GBSQF3FHF7FWZQNWGHAVQ804", "10043"] },
"name": "Production Web Dashboard Alerts",
"owning_team_ids": ["01G0J1EXE7AXZ2C93K61WBPYEH"],
"template": {
"attributes": [
{
"alert_attribute_id": "abc123",
"binding": {
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"merge_strategy": "first_wins",
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
}
}
],
"description": {
"literal": "SEV123",
"reference": "incident.severity"
},
"expressions": [
{
"else_branch": { "result": {
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
} },
"label": "Team Slack channel",
"operations": [
{
"branches": {
"branches": [
{
"condition_groups": [{ "conditions": [
{
"operation": "one_of",
"param_bindings": [
{
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
}
],
"subject": "incident.severity"
}
] }],
"result": {
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
}
}
],
"returns": {
"array": True,
"type": "IncidentStatus"
}
},
"cast": { "returns": {
"array": True,
"type": "IncidentStatus"
} },
"concatenate": { "reference": "catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]" },
"filter": { "condition_groups": [{ "conditions": [
{
"operation": "one_of",
"param_bindings": [
{
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
}
],
"subject": "incident.severity"
}
] }] },
"navigate": { "reference": "catalog_attribute[\"01FCNDV6P870EA6S7TK1DSYD5H\"]" },
"operation_type": "navigate",
"parse": {
"returns": {
"array": True,
"type": "IncidentStatus"
},
"source": "metadata.annotations[\"github.com/repo\"]"
}
}
],
"reference": "abc123",
"root_reference": "incident.status"
}
],
"is_private": False,
"title": {
"literal": "SEV123",
"reference": "incident.severity"
},
"visible_to_teams": {
"array_value": [
{
"literal": "SEV123",
"reference": "incident.severity"
}
],
"value": {
"literal": "SEV123",
"reference": "incident.severity"
}
}
}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
auto_resolve_incident_alerts: false,
auto_resolve_timeout_minutes: 1,
disabled: false,
email_options: {
redactions: ['credit_card_numbers'],
transform_expression: 'return {\n title: $.subject,\n description: $.text,\n status: $.subject.startsWith(\'[RESOLVED]\') ? \'resolved\' : \'firing\',\n deduplication_key: $.header_message_id,\n}'
},
heartbeat_options: {failure_threshold: 1, grace_period_seconds: 0, interval_seconds: 60},
http_custom_options: {
deduplication_key_path: '$.alert_id',
transform_expression: 'return {\n title: $.title || $.name || \'Unknown Alert\',\n status: $.status === \'resolved\' ? \'resolved\' : \'firing\',\n description: $.description || $.message || \'\',\n sourceURL: $.url || $.link || \'\',\n metadata: { team: $.team, severity: $.severity }\n}'
},
jira_options: {project_ids: ['01GBSQF3FHF7FWZQNWGHAVQ804', '10043']},
name: 'Production Web Dashboard Alerts',
owning_team_ids: ['01G0J1EXE7AXZ2C93K61WBPYEH'],
template: {
attributes: [
{
alert_attribute_id: 'abc123',
binding: {
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
merge_strategy: 'first_wins',
value: {literal: 'SEV123', reference: 'incident.severity'}
}
}
],
description: {literal: 'SEV123', reference: 'incident.severity'},
expressions: [
{
else_branch: {
result: {
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
value: {literal: 'SEV123', reference: 'incident.severity'}
}
},
label: 'Team Slack channel',
operations: [
{
branches: {
branches: [
{
condition_groups: [
{
conditions: [
{
operation: 'one_of',
param_bindings: [
{
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
value: {literal: 'SEV123', reference: 'incident.severity'}
}
],
subject: 'incident.severity'
}
]
}
],
result: {
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
value: {literal: 'SEV123', reference: 'incident.severity'}
}
}
],
returns: {array: true, type: 'IncidentStatus'}
},
cast: {returns: {array: true, type: 'IncidentStatus'}},
concatenate: {reference: 'catalog_attribute["01FCNDV6P870EA6S7TK1DSYD5H"]'},
filter: {
condition_groups: [
{
conditions: [
{
operation: 'one_of',
param_bindings: [
{
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
value: {literal: 'SEV123', reference: 'incident.severity'}
}
],
subject: 'incident.severity'
}
]
}
]
},
navigate: {reference: 'catalog_attribute["01FCNDV6P870EA6S7TK1DSYD5H"]'},
operation_type: 'navigate',
parse: {
returns: {array: true, type: 'IncidentStatus'},
source: 'metadata.annotations["github.com/repo"]'
}
}
],
reference: 'abc123',
root_reference: 'incident.status'
}
],
is_private: false,
title: {literal: 'SEV123', reference: 'incident.severity'},
visible_to_teams: {
array_value: [{literal: 'SEV123', reference: 'incident.severity'}],
value: {literal: 'SEV123', reference: 'incident.severity'}
}
}
})
};

fetch('https://api.incident.io/v2/alert_sources/{id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.incident.io/v2/alert_sources/{id}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PUT",
  CURLOPT_POSTFIELDS => json_encode([
    'auto_resolve_incident_alerts' => false,
    'auto_resolve_timeout_minutes' => 1,
    'disabled' => false,
    'email_options' => [
        'redactions' => [
                'credit_card_numbers'
        ],
        'transform_expression' => 'return {
  title: $.subject,
  description: $.text,
  status: $.subject.startsWith(\'[RESOLVED]\') ? \'resolved\' : \'firing\',
  deduplication_key: $.header_message_id,
}'
    ],
    'heartbeat_options' => [
        'failure_threshold' => 1,
        'grace_period_seconds' => 0,
        'interval_seconds' => 60
    ],
    'http_custom_options' => [
        'deduplication_key_path' => '$.alert_id',
        'transform_expression' => 'return {
  title: $.title || $.name || \'Unknown Alert\',
  status: $.status === \'resolved\' ? \'resolved\' : \'firing\',
  description: $.description || $.message || \'\',
  sourceURL: $.url || $.link || \'\',
  metadata: { team: $.team, severity: $.severity }
}'
    ],
    'jira_options' => [
        'project_ids' => [
                '01GBSQF3FHF7FWZQNWGHAVQ804',
                '10043'
        ]
    ],
    'name' => 'Production Web Dashboard Alerts',
    'owning_team_ids' => [
        '01G0J1EXE7AXZ2C93K61WBPYEH'
    ],
    'template' => [
        'attributes' => [
                [
                                'alert_attribute_id' => 'abc123',
                                'binding' => [
                                                                'array_value' => [
                                                                                                                                [
                                                                                                                                                                                                                                                                'literal' => 'SEV123',
                                                                                                                                                                                                                                                                'reference' => 'incident.severity'
                                                                                                                                ]
                                                                ],
                                                                'merge_strategy' => 'first_wins',
                                                                'value' => [
                                                                                                                                'literal' => 'SEV123',
                                                                                                                                'reference' => 'incident.severity'
                                                                ]
                                ]
                ]
        ],
        'description' => [
                'literal' => 'SEV123',
                'reference' => 'incident.severity'
        ],
        'expressions' => [
                [
                                'else_branch' => [
                                                                'result' => [
                                                                                                                                'array_value' => [
                                                                                                                                                                                                                                                                [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'literal' => 'SEV123',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'reference' => 'incident.severity'
                                                                                                                                                                                                                                                                ]
                                                                                                                                ],
                                                                                                                                'value' => [
                                                                                                                                                                                                                                                                'literal' => 'SEV123',
                                                                                                                                                                                                                                                                'reference' => 'incident.severity'
                                                                                                                                ]
                                                                ]
                                ],
                                'label' => 'Team Slack channel',
                                'operations' => [
                                                                [
                                                                                                                                'branches' => [
                                                                                                                                                                                                                                                                'branches' => [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'condition_groups' => [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'conditions' => [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'operation' => 'one_of',
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                'param_bindings' => [
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
[...]
